diff -r 4d0e5fb0c33d django/contrib/admin/sites.py
--- a/django/contrib/admin/sites.py	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/sites.py	Thu Sep 17 19:47:14 2009 -0300
@@ -349,7 +349,7 @@
                         app_dict[app_label]['models'].append(model_dict)
                     else:
                         app_dict[app_label] = {
-                            'name': app_label.title(),
+                            'name': _(app_label).title(),
                             'app_url': app_label + '/',
                             'has_module_perms': has_module_perms,
                             'models': [model_dict],
@@ -413,7 +413,7 @@
                             # something to display, add in the necessary meta
                             # information.
                             app_dict = {
-                                'name': app_label.title(),
+                                'name': _(app_label).title(),
                                 'app_url': '',
                                 'has_module_perms': has_module_perms,
                                 'models': [model_dict],
@@ -423,7 +423,7 @@
         # Sort the models alphabetically within each app.
         app_dict['models'].sort(lambda x, y: cmp(x['name'], y['name']))
         context = {
-            'title': _('%s administration') % capfirst(app_label),
+            'title': _('%(app_label)s administration') % {'app_label': capfirst(_(app_label))},
             'app_list': [app_dict],
             'root_path': self.root_path,
         }
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/app_index.html
--- a/django/contrib/admin/templates/admin/app_index.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/app_index.html	Thu Sep 17 19:47:14 2009 -0300
@@ -7,7 +7,7 @@
 <div class="breadcrumbs"><a href="../">
 {% trans "Home" %}</a> &rsaquo; 
 {% for app in app_list %}
-{% blocktrans with app.name as name %}{{ name }}{% endblocktrans %}
+{{ app.name }}
 {% endfor %}</div>{% endblock %}
 
 {% endif %} 
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/auth/user/change_password.html
--- a/django/contrib/admin/templates/admin/auth/user/change_password.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/auth/user/change_password.html	Thu Sep 17 19:47:14 2009 -0300
@@ -8,7 +8,7 @@
 {% block breadcrumbs %}{% if not is_popup %}
 <div class="breadcrumbs">
      <a href="../../../../">{% trans "Home" %}</a> &rsaquo;
-     <a href="../../../">{{ opts.app_label|capfirst|escape }}</a> &rsaquo;
+     <a href="../../../">{% filter capfirst %}{% trans opts.app_label %}{% endfilter %}</a> &rsaquo;
      <a href="../../">{{ opts.verbose_name_plural|capfirst }}</a> &rsaquo;
      <a href="../">{{ original|truncatewords:"18" }}</a> &rsaquo;
      {% trans 'Change password' %}
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/change_form.html
--- a/django/contrib/admin/templates/admin/change_form.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/change_form.html	Thu Sep 17 19:47:14 2009 -0300
@@ -15,8 +15,8 @@
 {% block breadcrumbs %}{% if not is_popup %}
 <div class="breadcrumbs">
      <a href="../../../">{% trans "Home" %}</a> &rsaquo;
-     <a href="../../">{{ app_label|capfirst|escape }}</a> &rsaquo; 
-     {% if has_change_permission %}<a href="../">{{ opts.verbose_name_plural|capfirst }}</a>{% else %}{{ opts.verbose_name_plural|capfirst }}{% endif %} &rsaquo; 
+     <a href="../../">{% filter capfirst %}{% trans app_label %}{% endfilter %}</a> &rsaquo;
+     {% if has_change_permission %}<a href="../">{{ opts.verbose_name_plural|capfirst }}</a>{% else %}{{ opts.verbose_name_plural|capfirst }}{% endif %} &rsaquo;
      {% if add %}{% trans "Add" %} {{ opts.verbose_name }}{% else %}{{ original|truncatewords:"18" }}{% endif %}
 </div>
 {% endif %}{% endblock %}
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/change_list.html
--- a/django/contrib/admin/templates/admin/change_list.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/change_list.html	Thu Sep 17 19:47:14 2009 -0300
@@ -24,11 +24,11 @@
       <a href="../../">
         {% trans "Home" %}
       </a>
-       &rsaquo; 
+       &rsaquo;
        <a href="../">
-         {{ app_label|capfirst }}
+         {% filter capfirst %}{% trans app_label %}{% endfilter %}
       </a>
-      &rsaquo; 
+      &rsaquo;
       {{ cl.opts.verbose_name_plural|capfirst }}
     </div>
   {% endblock %}
@@ -67,7 +67,7 @@
           </div>
         {% endif %}
       {% endblock %}
-      
+
       <form action="" method="post"{% if cl.formset.is_multipart %} enctype="multipart/form-data"{% endif %}>
       {% if cl.formset %}
         {{ cl.formset.management_form }}
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/delete_confirmation.html
--- a/django/contrib/admin/templates/admin/delete_confirmation.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/delete_confirmation.html	Thu Sep 17 19:47:14 2009 -0300
@@ -4,7 +4,7 @@
 {% block breadcrumbs %}
 <div class="breadcrumbs">
      <a href="../../../../">{% trans "Home" %}</a> &rsaquo;
-     <a href="../../../">{{ app_label|capfirst }}</a> &rsaquo; 
+     <a href="../../../">{% filter capfirst %}{% trans app_label %}{% endfilter %}</a> &rsaquo;
      <a href="../../">{{ opts.verbose_name_plural|capfirst }}</a> &rsaquo;
      <a href="../">{{ object|truncatewords:"18" }}</a> &rsaquo;
      {% trans 'Delete' %}
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/delete_selected_confirmation.html
--- a/django/contrib/admin/templates/admin/delete_selected_confirmation.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/delete_selected_confirmation.html	Thu Sep 17 19:47:14 2009 -0300
@@ -4,7 +4,7 @@
 {% block breadcrumbs %}
 <div class="breadcrumbs">
      <a href="../../">{% trans "Home" %}</a> &rsaquo;
-     <a href="../">{{ app_label|capfirst }}</a> &rsaquo;
+     <a href="../">{% filter capfirst %}{% trans app_label %}{% endfilter %}</a> &rsaquo;
      <a href="./">{{ opts.verbose_name_plural|capfirst }}</a> &rsaquo;
      {% trans 'Delete multiple objects' %}
 </div>
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/index.html
--- a/django/contrib/admin/templates/admin/index.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/index.html	Thu Sep 17 19:47:14 2009 -0300
@@ -15,8 +15,8 @@
 {% if app_list %}
     {% for app in app_list %}
         <div class="module">
-        <table summary="{% blocktrans with app.name as name %}Models available in the {{ name }} application.{% endblocktrans %}">
-        <caption><a href="{{ app.app_url }}" class="section">{% blocktrans with app.name as name %}{{ name }}{% endblocktrans %}</a></caption>
+        <table summary="Models available in the {% trans app.name %} application.">
+        <caption><a href="{{ app.app_url }}" class="section">{{ app.name }}</a></caption>
         {% for model in app.models %}
             <tr>
             {% if model.perms.change %}
diff -r 4d0e5fb0c33d django/contrib/admin/templates/admin/object_history.html
--- a/django/contrib/admin/templates/admin/object_history.html	Wed Sep 16 09:09:47 2009 -0300
+++ b/django/contrib/admin/templates/admin/object_history.html	Thu Sep 17 19:47:14 2009 -0300
@@ -3,10 +3,10 @@
 
 {% block breadcrumbs %}
 <div class="breadcrumbs">
-    <a href="../../../../">{% trans 'Home' %}</a> &rsaquo; 
-    <a href="../../../">{{ app_label|capfirst }}</a> &rsaquo; 
-    <a href="../../">{{ module_name }}</a> &rsaquo; 
-    <a href="../">{{ object|truncatewords:"18" }}</a> &rsaquo; 
+    <a href="../../../../">{% trans 'Home' %}</a> &rsaquo;
+    <a href="../../../">{% filter capfirst %}{% trans app_label %}{% endfilter %}</a> &rsaquo;
+    <a href="../../">{{ module_name }}</a> &rsaquo;
+    <a href="../">{{ object|truncatewords:"18" }}</a> &rsaquo;
     {% trans 'History' %}
 </div>
 {% endblock %}