diff --git a/django/core/files/storage.py b/django/core/files/storage.py
index 4f27502..0746331 100644
--- a/django/core/files/storage.py
+++ b/django/core/files/storage.py
@@ -2,6 +2,7 @@ import os
 import errno
 import urlparse
 import itertools
+import datetime
 
 from django.conf import settings
 from django.core.exceptions import ImproperlyConfigured, SuspiciousOperation
@@ -120,6 +121,30 @@ class Storage(object):
         """
         raise NotImplementedError()
 
+    def accessed_time(self, name):
+        """
+        Returns the last accessed time (as Datetime object) for a given name.
+        If the subclass don't support accessed times, a NotImplementedError 
+        should be raised. (just dont overwrite this method in the subclass)
+        """
+        raise NotImplementedError("This backend doesn't support accessed time.")
+
+    def created_time(self, name):
+        """
+        Returns the creation time (as Datetime object) for a given name.
+        If the subclass don't support creation times, a NotImplementedError
+        should be raised. (just dont overwrite this method in the subclass)
+        """
+        raise NotImplementedError("This backend doesn't support created time.")
+
+    def modified_time(self, name):
+        """
+        Returns the last modified time (as Datetime object) for a given name.
+        If the subclass don't support modified times, a NotImplementedError
+        should be raised. (just dont overwrite this method in the subclass)
+        """
+        raise NotImplementedError("This backend doesn't support modified time.")
+
 class FileSystemStorage(Storage):
     """
     Standard filesystem storage
@@ -220,6 +245,18 @@ class FileSystemStorage(Storage):
             raise ValueError("This file is not accessible via a URL.")
         return urlparse.urljoin(self.base_url, name).replace('\\', '/')
 
+    def accessed_time(self, name):
+        return datetime.datetime.fromtimestamp(
+            os.path.getatime(self.path(name)))
+
+    def created_time(self, name):
+        return datetime.datetime.fromtimestamp(
+            os.path.getctime(self.path(name)))
+
+    def modified_time(self, name):
+        return datetime.datetime.fromtimestamp(
+            os.path.getmtime(self.path(name)))
+
 def get_storage_class(import_path=None):
     if import_path is None:
         import_path = settings.DEFAULT_FILE_STORAGE
diff --git a/docs/ref/files/storage.txt b/docs/ref/files/storage.txt
index 2b055bb..59cb3aa 100644
--- a/docs/ref/files/storage.txt
+++ b/docs/ref/files/storage.txt
@@ -13,6 +13,27 @@ The local filesystem path where the file can be opened using Python's standard
 ``open()``. For storage systems that aren't accessible from the local
 filesystem, this will raise ``NotImplementedError`` instead.
 
+``Storage.accessed_time(name)``
+~~~~~~~~~~~~~~~~~~~~~~
+
+Returns a ``Datetime`` object containing the last accessed time of the file.
+For storage systems that aren't able to return the last accessed time, this
+will raise ``NotImplementedError`` instead.
+
+``Storage.created_time(name)``
+~~~~~~~~~~~~~~~~~~~~~~
+
+Returns a ``Datetime`` object containing the creation time of the file.
+For storage systems that aren't able to return the creation time, this
+will raise ``NotImplementedError`` instead.
+
+``Storage.modified_time(name)``
+~~~~~~~~~~~~~~~~~~~~~~
+
+Returns a ``Datetime`` object containing the last modified time. For storage
+systems that aren't able to return the last modified time, this will raise
+``NotImplementedError`` instead.
+
 ``Storage.size(name)``
 ~~~~~~~~~~~~~~~~~~~~~~
 
diff --git a/tests/regressiontests/file_storage/tests.py b/tests/regressiontests/file_storage/tests.py
index 2c5f0f4..96bf1dc 100644
--- a/tests/regressiontests/file_storage/tests.py
+++ b/tests/regressiontests/file_storage/tests.py
@@ -6,9 +6,10 @@ import tempfile
 import time
 import unittest
 from cStringIO import StringIO
+from datetime import datetime
 from django.conf import settings
 from django.core.exceptions import SuspiciousOperation
-from django.core.files.base import ContentFile
+from django.core.files.base import ContentFile, File
 from django.core.files.images import get_image_dimensions
 from django.core.files.storage import FileSystemStorage
 from django.core.files.uploadedfile import UploadedFile
@@ -57,6 +58,57 @@ class FileStorageTests(unittest.TestCase):
         self.storage.delete('storage_test')
         self.failIf(self.storage.exists('storage_test'))
 
+    def test_file_accessed_time(self):
+        """
+        File storage returns a Datetime object for the last accessed time of
+        a file.
+        """
+        self.failIf(self.storage.exists('test.file'))
+
+        f = File(open(__file__, 'rb'))
+        f_name = self.storage.save('test.file', f)
+
+        self.assertEqual(
+            self.storage.accessed_time(f_name),
+            datetime.fromtimestamp(os.path.getatime(self.storage.path(f_name)))
+        )
+
+        self.storage.delete(f_name)
+
+    def test_file_created_time(self):
+        """
+        File storage returns a Datetime object for the creation time of
+        a file.
+        """
+        self.failIf(self.storage.exists('test.file'))
+
+        f = File(open(__file__, 'rb'))
+        f_name = self.storage.save('test.file', f)
+
+        self.assertEqual(
+            self.storage.created_time(f_name),
+            datetime.fromtimestamp(os.path.getctime(self.storage.path(f_name)))
+        )
+
+        self.storage.delete(f_name)
+
+    def test_file_modified_time(self):
+        """
+        File storage returns a Datetime object for the last modified time of
+        a file.
+        """
+        self.failIf(self.storage.exists('test.file'))
+
+        f = File(open(__file__, 'rb'))
+        f_name = self.storage.save('test.file', f)
+
+        self.assertEqual(
+            self.storage.modified_time(f_name),
+            datetime.fromtimestamp(os.path.getmtime(self.storage.path(f_name)))
+        )
+
+        self.storage.delete(f_name)
+
     def test_file_storage_prevents_directory_traversal(self):
         """
         File storage prevents directory traversal (files can only be accessed if